Package tigase.xmpp.impl

# Class MessageCarbons

java.lang.Object
tigase.xmpp.XMPPProcessor
tigase.xmpp.impl.MessageCarbons

All Implemented Interfaces:
  `Comparable<XMPPImplIfc>`, `SaslAuth2.Inline`, `XMPPImplIfc`, `XMPPPacketFilterIfc`, `XMPPProcessorConcurrencyAwareIfc`, `XMPPProcessorIfc`

@Bean(name="message-carbons", parent=SessionManager.class, active=true) public class MessageCarbons extends XMPPProcessor implements XMPPProcessorIfc, XMPPPacketFilterIfc, SaslAuth2.Inline
MessageCarbons class implements XEP-0280 Message Carbons protocol extension.

Author:
  andrzej

- ## Nested Class Summary

  Nested Classes
  Modifier and Type
  Class
  Description
  `static class`
  `MessageCarbons.MessageCarbonsStateChangedEvent`
  Event class responsible for notification other sessions of same user that message carbons state was changed.

  ## Nested classes/interfaces inherited from interface tigase.xmpp.impl.SaslAuth2.Inline

  `SaslAuth2.Inline.Action, SaslAuth2.Inline.Result`

- ## Field Summary

  Fields
  Modifier and Type
  Field
  Description
  `protected static final String`
  `ID`
  `static final String`
  `XMLNS`

  ### Fields inherited from class tigase.xmpp.XMPPProcessor

  `ALL_NAMES, ALL_PATHS, cmpInfo`

  ### Fields inherited from interface tigase.xmpp.XMPPImplIfc

  `CLIENT_XMLNS`

- ## Constructor Summary

  Constructors
  Constructor
  Description
  `MessageCarbons()`

- ## Method Summary

  Modifier and Type
  Method
  Description
  `boolean`
  `canHandle(XMPPResourceConnection connection, Element el)`
  `void`
  `filter(Packet packet, XMPPResourceConnection session, NonAuthUserRepository repo, Queue<Packet> results)`
  `String[]`
  `getMsgCarbonPaths()`
  `String`
  `id()`
  Method `id` returns a unique ID of the plugin.
  `protected Set<JID>`
  `prepareSkipForkingToList(Packet packet, XMPPResourceConnection session, Map<JID,Boolean> resources)`
  `protected void`
  `presenceUpdate(UserPresenceChangedEvent presenceEvent)`
  Method handles `UserPresenceChangedEvent` and synchronizes state of JIDs for MessageCarbons for particular user.
  `void`
  `process(Packet packet, XMPPResourceConnection session, NonAuthUserRepository repo, Queue<Packet> results, Map<String,Object> settings)`
  `CompletableFuture<SaslAuth2.Inline.Result>`
  `process(XMPPResourceConnection session, Element action)`
  `void`
  `setMsgCarbonPaths(String[] matcherStrs)`
  `protected boolean`
  `shouldSendCarbons(Packet packet, XMPPResourceConnection session)`
  `protected void`
  `stateChanged(MessageCarbons.MessageCarbonsStateChangedEvent event)`
  Method responsible for handing `MessageCarbonsStateChangedEvent` and marking JIDs of user as MessageCarbons enabled/disabled.
  `Element[]`
  `supDiscoFeatures(XMPPResourceConnection session)`
  Method `supDiscoFeatures` returns an array of XML `Element`s with service discovery features which have to be returned to the client uppon request.
  `String[][]`
  `supElementNamePaths()`
  Method `supElementNamePaths` returns an array of element names in form of a full path to the XML element for stanzas which can be processed by this plugin.
  `String[]`
  `supNamespaces()`
  Method `supNamespaces` returns an array of name-spaces for stanzas which can be processed by this plugin.
  `Element[]`
  `supStreamFeatures(SaslAuth2.Inline.Action action)`

  ### Methods inherited from class tigase.xmpp.XMPPProcessor

  `canHandle, compareTo, concurrentQueuesNo, getComponentInfo, getInstance, getQueueSize, getStatistics, getThreadsNo, init, supStreamFeatures, supTypes, toString`

  ### Methods inherited from class java.lang.Object

  `clone, equals, finalize, getClass, hashCode, notify, notifyAll, wait, wait, wait`

  ### Methods inherited from interface java.lang.Comparable

  `compareTo`

  ### Methods inherited from interface tigase.xmpp.XMPPImplIfc

  `canHandle, concurrentQueuesNo, getComponentInfo, getStatistics, init, supStreamFeatures, supTypes`

- ## Field Details

  - ### XMLNS

    public static final String XMLNS
    See Also:
      - Constant Field Values

  - ### ID

    protected static final String ID
    See Also:
      - Constant Field Values

- ## Constructor Details

  - ### MessageCarbons

    public MessageCarbons()

- ## Method Details

  - ### id

    public String id()
    Description copied from interface: `XMPPImplIfc`
    Method `id` returns a unique ID of the plugin. Each plugin has own, unique ID which is used in the configuration file to determine whether it needs to be loaded or not. In most cases the ID can be equal to XMLNS of the packages processed by the plugin.
    Specified by:
      `id` in interface `XMPPImplIfc`
    Returns:
      a `String` value

  - ### canHandle

    public boolean canHandle(XMPPResourceConnection connection, Element el)
    Specified by:
      `canHandle` in interface `SaslAuth2.Inline`

  - ### getMsgCarbonPaths

    public String[] getMsgCarbonPaths()

  - ### setMsgCarbonPaths

    public void setMsgCarbonPaths(String[] matcherStrs)

  - ### process

    public void process(Packet packet, XMPPResourceConnection session, NonAuthUserRepository repo, Queue<Packet> results, Map<String,Object> settings) throws XMPPException
    Specified by:
      `process` in interface `XMPPProcessorIfc`
    Parameters:
      `packet` - packet is which being processed. This parameter may never be null. Even though this is not immutable object it mustn't be altered. None of it's fields or attributes can be changed during processing.
      `session` - user session which keeps all the user session data and also gives an access to the user's repository data. It allows for storing information in a permanent storage or in memory only during the live of the online session. This parameter can be null if there is no online user session at the time of the packet processing.
      `repo` - this is a user data storage which is normally used when the user session (parameter above) is null. This is repository allows for a very restricted access only. It allows for storing some user private data (doesn't allow overwriting existing data) like messages for offline users and it also allows for reading user public data like VCard.
      `results` - this a collection with packets which have been generated as input packet processing results. Regardless a response to a user request is sent or the packet is forwarded to it's destination it is always required that a copy of the input packet is created and stored in the results queue.
      `settings` - this map keeps plugin specific settings loaded from the Tigase server configuration. In most cases it is unused, however if the plugin needs to access an external database that this is a way to pass database connection string to the plugin.
    Throws:
      `XMPPException`

  - ### process

    public CompletableFuture<SaslAuth2.Inline.Result> process(XMPPResourceConnection session, Element action)
    Specified by:
      `process` in interface `SaslAuth2.Inline`

  - ### supStreamFeatures

    public Element[] supStreamFeatures(SaslAuth2.Inline.Action action)
    Specified by:
      `supStreamFeatures` in interface `SaslAuth2.Inline`

  - ### prepareSkipForkingToList

    protected Set<JID> prepareSkipForkingToList(Packet packet, XMPPResourceConnection session, Map<JID,Boolean> resources) throws NotAuthorizedException
    Throws:
      `NotAuthorizedException`

  - ### supDiscoFeatures

    public Element[] supDiscoFeatures(XMPPResourceConnection session)
    Description copied from interface: `XMPPImplIfc`
    Method `supDiscoFeatures` returns an array of XML `Element`s with service discovery features which have to be returned to the client uppon request. Service discovery features returned by this method correspond to services supported by this plugin.
    Specified by:
      `supDiscoFeatures` in interface `XMPPImplIfc`
    Overrides:
      `supDiscoFeatures` in class `XMPPProcessor`
    Parameters:
      `session` - a `XMPPResourceConnection` value
    Returns:
      an `Element[]` value

  - ### supElementNamePaths

    public String[][] supElementNamePaths()
    Description copied from interface: `XMPPImplIfc`
    Method `supElementNamePaths` returns an array of element names in form of a full path to the XML element for stanzas which can be processed by this plugin. Each element name path corresponds to XMLNS returned in array by `supNamespaces()` method. The element path itself is represented by a String array with each path element as a separate String.
    Specified by:
      `supElementNamePaths` in interface `XMPPImplIfc`
    Overrides:
      `supElementNamePaths` in class `XMPPProcessor`
    Returns:
      a `String[][]` value is an array for element paths for which the plugin offers processing capabilities. Each path is in form of a String array in order to reduce parsing overhead.

  - ### supNamespaces

    public String[] supNamespaces()
    Description copied from interface: `XMPPImplIfc`
    Method `supNamespaces` returns an array of name-spaces for stanzas which can be processed by this plugin. Each namespace corresponds to element name returned in array by `supElemenets()` method.
    Specified by:
      `supNamespaces` in interface `XMPPImplIfc`
    Overrides:
      `supNamespaces` in class `XMPPProcessor`
    Returns:
      a `String[]` value

  - ### filter

    public void filter(Packet packet, XMPPResourceConnection session, NonAuthUserRepository repo, Queue<Packet> results)
    Specified by:
      `filter` in interface `XMPPPacketFilterIfc`

  - ### stateChanged

    @HandleEvent protected void stateChanged(MessageCarbons.MessageCarbonsStateChangedEvent event)
    Method responsible for handing `MessageCarbonsStateChangedEvent` and marking JIDs of user as MessageCarbons enabled/disabled.

  - ### presenceUpdate

    @HandleEvent protected void presenceUpdate(UserPresenceChangedEvent presenceEvent) throws NotAuthorizedException
    Method handles `UserPresenceChangedEvent` and synchronizes state of JIDs for MessageCarbons for particular user.
    Throws:
      `NotAuthorizedException`

  - ### shouldSendCarbons

    protected boolean shouldSendCarbons(Packet packet, XMPPResourceConnection session)